#include <string>
#include <iostream>
#include <fstream>
#include <vector>
using namespace std;


vector< int > find_starts_of_tags( string genome, string tag)
{
    vector< int > starts;

    int pos = 0;

    bool done = false;

    for(int i = 0, tfind; (tfind = genome.find(tag, i)) != string::npos; i = tfind + 1)
    {
	starts.push_back( tfind );	
    }

    return starts;
}


main()
{
    ifstream genome_file("dros_x2.fasta");
    
    string genome, temp;

    while( getline( genome_file, temp ))
	genome += temp;

    std::cout << genome.size() << "\n";
    
    vector< string > ditags;
    vector< string > left_ditags;
    vector< string > right_ditags;

    ifstream ditag_file("ditags.txt");

    string ditag, ltag, rtag;

    while( getline( ditag_file, ditag ))
    {
	ditags.push_back( ditag );
	left_ditags.push_back( ditag.substr(0,11) );
	right_ditags.push_back( ditag.substr(11,11) );
	
    }

    std::cout << ditags.size() << endl;
    std::cout << left_ditags.size() << endl;
    std::cout << right_ditags.size() << endl;

    int t = 3;
    
    std::cout << left_ditags[t].size() << endl;

    for ( int t = 0; t < ditags.size(); t++ )
    {
	
	vector< int > ltest = find_starts_of_tags( genome, left_ditags[t] );
	vector< int > rtest = find_starts_of_tags( genome, right_ditags[t] );
	cout << endl;
	cout << endl;
	printf("checking ditag %d %s: left matches %d right matches %d\n",t,ditags[t].c_str(), ltest.size(), rtest.size());
	if ( ltest.size() != 0 && rtest.size() != 0 && ltest.size() < 2000 && rtest.size() < 2000 )
	{
	    
	    cout << "\t left starts: ";
	    for ( int i = 0; i < ltest.size(); i++ )
		printf("%d ",ltest[i] );

	    cout << "\n\t right starts: ";
	    for ( int i = 0; i < rtest.size(); i++ )
		printf("%d ",rtest[i] );

	    cout << endl;
	    
	    // search for rights that are
	    for ( int i = 0; i < ltest.size(); i++ )
	    {
		for ( int j = 0; j < rtest.size(); j++ )
		{
		    int dist = rtest[j] - ltest[i];
		    printf("left %d right %d dist %d\n", ltest[i], rtest[j], dist );
		    
		    if ( dist > 10000 && dist < 15000 )
			printf("\t Possible match! ditag %d left %d right %d dist %d\n",t,ltest[i], rtest[j],dist);
		}
	    }
	}
	else
	    printf("NO CHECK: size ltest %d rtest %d\n",ltest.size(), rtest.size() );
    }
}



