#include <string>
#include <iostream>
#include <fstream>
#include <vector>
using namespace std;


vector< int > find_starts_of_tags( const string &genome, const string &tag)
{
    vector< int > starts;

    int pos = 0;

    bool done = false;

    for(int i = 0, tfind; (tfind = genome.find(tag, i)) != string::npos; i = tfind + 1)
    {
	starts.push_back( tfind );	
    }

    return starts;
}


main()
{
    ifstream genome_file("dros_x2.fasta");
    
    string genome, temp;

    while( getline( genome_file, temp ))
	genome += temp;

    std::cout << genome.size() << "\n";
    
    vector< string > ditags;
    vector< string > left_ditags;
    vector< string > right_ditags;

    ifstream ditag_file("ditags.txt");

    string ditag, ltag, rtag;

    while( getline( ditag_file, ditag ))
    {
	ditags.push_back( ditag );
	left_ditags.push_back( ditag.substr(0,11) );
	right_ditags.push_back( ditag.substr(11,11) );
	
    }

    std::cout << ditags.size() << endl;
    std::cout << left_ditags.size() << endl;
    std::cout << right_ditags.size() << endl;

    int t = 3;
    
    std::cout << left_ditags[t].size() << endl;

    for ( int t = 0; t < ditags.size(); t++ )
    {
	
	vector< int > ltest = find_starts_of_tags( genome, left_ditags[t] );

	printf("checking ditag %d %s: left matches %d\n",t,ditags[t].c_str(), ltest.size() );
	if ( ltest.size() != 0 && ltest.size() < 2000 )
	    for ( int l = 0; l < ltest.size(); l++ )
	    {
		int s = std::min( ltest[l] + 9000, (int)genome.size() - 1);
		string genome_portion = genome.substr( s, 7000 );
		vector< int > rtest = find_starts_of_tags( genome_portion, right_ditags[t] );
		if ( rtest.size() < 2000 )
		{

		    if ( rtest.size() != 0 )
		    {
			cout << "\t left start: " << ltest[l];
			cout << " matching right offsets: ";
			for ( int i = 0; i < rtest.size(); i++ )
			    printf("%d ",rtest[i] );
			
			cout << endl;
		    }
		}
		else
		    printf("NO CHECK: rtest %d\n",rtest.size() );
	    }
	else
	    printf("NO CHECK: size ltest %d\n",ltest.size() );

    }
}



